﻿import numpy as np
import shelve
import sys

# 最初の引数には、shelveのフルパスが入っている
shelve_fullpath = sys.argv[1]

# インプロセス(hmPython側のpython)からshelveへと格納された情報を拾う。
data = shelve.open(shelve_fullpath)
arg_list = data['from_inprocess_list']
data.close()

result = np.array(arg_list)
result = result.T # 転置行列
data = shelve.open(shelve_fullpath)

# numpyのオブジェクトを直接代入すると、インプロセスの方でnumpyが勝手に読み込まれてしまう
# それを防止するため、numpyの配列ではなく、あくまでも普通のpythonの多次元リストになおしておく
data['from_outprocess_list'] = result.tolist()

data['from_outprocess_dict'] = {"aaaa":33}

data.close()

